#include <iostream>

using namespace std;

int main()
{
    int N, Q, brojac, brojPakovanjaPoDanu, brojPojedenihPakovanjaZaPitanje;
    cin >> N >> Q;
    int p[N], d[N], k[Q];
    for(int i = 0; i < N ; i++)
    {
        cin >> d[i] >> p[i];
    }
    for(int j = 0; j < Q; j++)
    {
        cin >> k[j];
    }
    for(int j = 0; j < Q; j++)
    {
        brojac = 0; brojPakovanjaPoDanu = 0; brojPojedenihPakovanjaZaPitanje = 0;
        for(int m = 0; m < k[j]; m++)
        {
            if((m+1) == d[brojac])
            {
                brojPakovanjaPoDanu += p[brojac];
                brojac++;
            }
            if(brojPakovanjaPoDanu != 0)
            {
                brojPakovanjaPoDanu -= 1;
                brojPojedenihPakovanjaZaPitanje += 1;
            }
        }
        cout << brojPojedenihPakovanjaZaPitanje << endl;
    }
    return 0;
}